//+----------------------------------------------------------------------------+
//|                                                                  EMWL.mq4  |
//|                                               http://Etrade24.tripod.com/  |
//|                                               http://BigGame24.tripod.com/ |
//|  16.04.2011  Moving SL to Withouth Loss.                                   |
//+----------------------------------------------------------------------------+
#property copyright "http://Etrade24.tripod.com/"
#property link      "http://BigGame24.tripod.com/"

//------- Input Parameters ----------------------------------------------------
extern int  LevelProfit = 4;     // Level Profit
extern int  LevelWLoss  = 1;      // Level Without Loss
bool ShowComment = False;   // Price information
extern bool SoundAlert  = False;   // Sound

//+----------------------------------------------------------------------------+
//|  Custor expert deinitialization function                                   |
//+----------------------------------------------------------------------------+
void deinit() { Comment("*** Etrade24.tripod.com *** BigGame24.tripod.com"); }

//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  bool   fm;
  double pBid, pAsk, pp;
  int    i, nd, o=OrdersTotal();
  string comm="";
Comment("________________________________"
         + "\n"
         + "*** Etrade24.tripod.com"
         + "\n"
         + "*** BigGame24.tripod.com"
         + "\n"
         + "________________________________"
         + "\n"
         + "Expert-Moving to WL" 
         + "\n" 
         + "________________________________"  
         + "\n" 
         + "Broker:         " + AccountCompany()
         + "\n"
         + "Time Local:    " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS)
         + "\n"        
         + "________________________________"  
         + "\n" 
         + "Name:             " + AccountName() 
         + "\n" 
         + "Account Number:        " + AccountNumber()
         + "\n" 
         + "Account Currency:      " + AccountCurrency()   
         + "\n"
         + "Account Leverage:      " + DoubleToStr(AccountLeverage(), 0) 
         + "\n"
         + "________________________________"
         + "\n"           
         + "Account BALANCE:     " + DoubleToStr(AccountBalance(), 2)          
         + "\n" 
         + "Account EQUITY:       " + DoubleToStr(AccountEquity(), 2)
         + "\n" 
         + "Used MARGIN:             " + DoubleToStr(AccountMargin(), 2) 
         + "\n" 
         + "________________________________"
         + "\n" 
         + "PROFIT:                   " + DoubleToStr(AccountEquity() - AccountBalance(), 2) 
         + "\n"
         + "PROFIT %:               " + DoubleToStr(100.0 * (AccountEquity() / AccountBalance() - 1.0), 3) + " %" 
         + "\n" 
         + "________________________________" 
         + "\n"
         + "LevelProfit:                "+DoubleToStr(LevelProfit, 0)
         + "\n"
         + "LevelWLoss:               "+DoubleToStr(LevelWLoss, 0)
         + "\n" 
         + "________________________________");
  for (i=0; i<o; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      nd=MarketInfo(OrderSymbol(), MODE_DIGITS);
      pp=MarketInfo(OrderSymbol(), MODE_POINT);
      comm=comm+OrderSymbol()+"  : "+DoubleToStr(OrderOpenPrice(), nd)+
           "  SL="+DoubleToStr(OrderStopLoss(), nd);
      if (OrderType()==OP_BUY) {
        comm=comm+"("+DoubleToStr((OrderStopLoss()-OrderOpenPrice())/pp, 0)+")\n";
        if (OrderStopLoss()-OrderOpenPrice()<LevelWLoss*pp) {
          pBid=MarketInfo(OrderSymbol(), MODE_BID);
          if (pBid-OrderOpenPrice()>LevelProfit*pp) {
            fm=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+LevelWLoss*pp,OrderTakeProfit(),CLR_NONE);
          }
        }
      }
      if (OrderType()==OP_SELL) {
        comm=comm+"("+DoubleToStr((OrderOpenPrice()-OrderStopLoss())/pp,0)+")\n";
        if (OrderStopLoss()==0 || OrderOpenPrice()-OrderStopLoss()<LevelWLoss*pp) {
          pAsk=MarketInfo(OrderSymbol(), MODE_ASK);
          if (OrderOpenPrice()-pAsk>LevelProfit*pp) {
            fm=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-LevelWLoss*pp,OrderTakeProfit(),CLR_NONE);
          }
        }
      }
      if (fm) {
        if (SoundAlert) PlaySound("alert2");
        break;
      }
    }
  }
  if (ShowComment) Comment(comm);
}
//+------------------------------------------------------------------+

